001/*
002 * Copyright (c) 2011-2017 Nexmo Inc
003 *
004 * Permission is hereby granted, free of charge, to any person obtaining a copy
005 * of this software and associated documentation files (the "Software"), to deal
006 * in the Software without restriction, including without limitation the rights
007 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
008 * copies of the Software, and to permit persons to whom the Software is
009 * furnished to do so, subject to the following conditions:
010 *
011 * The above copyright notice and this permission notice shall be included in
012 * all copies or substantial portions of the Software.
013 *
014 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
015 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
016 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
017 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
018 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
019 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
020 * THE SOFTWARE.
021 */
022package com.nexmo.client.voice.endpoints;
023
024import com.nexmo.client.HttpWrapper;
025import com.nexmo.client.NexmoClientException;
026import com.nexmo.client.auth.JWTAuthMethod;
027import com.nexmo.client.voice.CallModifier;
028import com.nexmo.client.voice.ModifyCallResponse;
029import org.apache.commons.logging.Log;
030import org.apache.commons.logging.LogFactory;
031import org.apache.http.HttpResponse;
032import org.apache.http.client.methods.RequestBuilder;
033import org.apache.http.entity.StringEntity;
034import org.apache.http.impl.client.BasicResponseHandler;
035import org.apache.http.util.EntityUtils;
036
037import java.io.IOException;
038import java.io.UnsupportedEncodingException;
039
040// TODO: Create a package for these endpoint methods
041public class ModifyCallMethod extends AbstractMethod<CallModifier, ModifyCallResponse> {
042    private static final Log LOG = LogFactory.getLog(ModifyCallMethod.class);
043
044    private static final String DEFAULT_URI = "https://api.nexmo.com/v1/calls/";
045    private static final Class[] ALLOWED_AUTH_METHODS = new Class[]{JWTAuthMethod.class};
046    private String uri = DEFAULT_URI;
047
048    public ModifyCallMethod(HttpWrapper httpWrapper) {
049        super(httpWrapper);
050    }
051
052    @Override
053    protected Class[] getAcceptableAuthMethods() {
054        return ALLOWED_AUTH_METHODS;
055    }
056
057    @Override
058    public RequestBuilder makeRequest(CallModifier request) throws NexmoClientException, UnsupportedEncodingException {
059        String uri = this.uri + request.getUuid();
060        return RequestBuilder
061                .put(uri)
062                .setHeader("Content-Type", "application/json")
063                .setEntity(new StringEntity(request.toJson()));
064    }
065
066    @Override
067    public ModifyCallResponse parseResponse(HttpResponse response) throws IOException {
068        String json = new BasicResponseHandler().handleResponse(response);
069        if (response.getStatusLine().getStatusCode() == 200) {
070            return ModifyCallResponse.fromJson(json);
071        } else {
072            return null;
073        }
074    }
075
076    public void setUri(String uri) {
077        this.uri = uri;
078    }
079}